//per scrivere su file
var fs = require('fs');

//console.log(process.argv[2]) //path descrizione descrizione
//console.log(process.argv[3]) //path dove vuoi mettere i test generati

//nome della specifica
var spec_name = process.argv[2];

//directory che contiene la specifica (stesso nome della descrizione)
var dir = process.argv[3];

//Import your openAPI spec:
var openApiSpec = require(spec_name);

//per la validazione
var ZSchema = require('z-schema');
var zSchema = new ZSchema();
var swaggerSchema = require('swagger-schema-official/schema');
var deref = require('json-schema-deref-sync');


if (!openApiSpec) throw new Error('please provide a openAPI json to start');
if (!zSchema.validate(openApiSpec, swaggerSchema)) throw new Error('openAPI spec not valid');

var spec = deref(openApiSpec);

var readline = require('readline');
var rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
  terminal: false
});
var desiredParams = []

console.log('Inserisci i nomi dei parametri da aggiungere allo scheletro Json\nTermina con una riga vuota')

rl.on('line', function(line){
	if (line != '') {
		desiredParams.push(line)
	}
	else {
		console.log(desiredParams)
		//console.log(spec);
		var pathMocks = {};
		for (var localPath in spec.paths) {
			console.log(localPath);
			for (var operation in spec.paths[localPath]) {
				console.log(operation);
				var array_parameters = spec.paths[localPath][operation].parameters;
				var pathParams = [];
				if(array_parameters && array_parameters.length > 0) {
					array_parameters.forEach(function(param) {
						//console.log(param);
						if(param.in == 'path' || desiredParams.includes(param.name)) {
							console.log(param.name);
							pathParams.push(param.name);										
						}
					});
					if(pathParams && pathParams.length > 0 ) {
						if (!pathMocks[localPath]) {
							pathMocks[localPath] = {};
						}
						pathMocks[localPath][operation] = {};
						var array_responses = spec.paths[localPath][operation].responses;
						if (array_responses['default'] == undefined) {
							array_responses['default'] = {}
						}
						for(code in array_responses) {
							pathMocks[localPath][operation][code] = [];
							console.log(code);
							var paramValuesObj = {};
							pathParams.forEach(function (paramName) {
								paramValuesObj[paramName] = code + '_' + paramName;
							});
							pathMocks[localPath][operation][code][0] = paramValuesObj;
						}
					}
				}
				//responsePaths.push({ path: localPath, operation: operation });
			}
			console.log('_____________________________________');
		}
		console.log('++++++++++++++++++++++++++++++++');
		var file_content = JSON.stringify(pathMocks , null, 2);
		//console.log(file_content);
		fs.writeFile(dir + '/path_param_skeleton.json', file_content, function(err) {
			if(err) {
				return console.log(err);
			}
			console.log("The file was saved!");
			process.exit()
		}); 
	}
})
